"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const routerCore = require("@tanstack/router-core");
const solidRouter = require("@tanstack/solid-router");
function useServerFn(serverFn) {
  const router = solidRouter.useRouter();
  return async (...args) => {
    try {
      const res = await serverFn(...args);
      if (routerCore.isRedirect(res)) {
        throw res;
      }
      return res;
    } catch (err) {
      if (routerCore.isRedirect(err)) {
        err.options._fromLocation = router.state.location;
        return router.navigate(router.resolveRedirect(err).options);
      }
      throw err;
    }
  };
}
exports.useServerFn = useServerFn;
//# sourceMappingURL=useServerFn.cjs.map
